/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 187 by dpavlin, Tue Mar 16 21:36:45 2010 UTC revision 216 by dpavlin, Wed May 26 10:19:05 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    
44  lxc_status() {  lxc_status() {
45          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                  on_boot="       "                  boot="-"
47                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49          done                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
50                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51            done ) | column -t
52  }  }
53    
54    
# Line 73  setup_inittab() { Line 79  setup_inittab() {
79  }  }
80    
81    
82    lxc_log() {
83            echo `date +%Y-%m-%dT%H:%M:%S` $*
84    }
85    
86    
87  lxc_kill() {  lxc_kill() {
88          name=$1          name=$1
89          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 93  lxc_kill() {
93                  lxc-info -n $name                  lxc-info -n $name
94                  exit 1                  exit 1
95          fi          fi
96          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
97          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
98  }  }
99    
100  lxc_stop() {  lxc_stop() {
101            lxc_log "$name stop"
102          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
103          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
104            lxc_log "$name stoped"
105  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
106  }  }
107    
# Line 97  lxc_start() { Line 110  lxc_start() {
110          name=$1          name=$1
111    
112          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
113                  echo "$name start"                  lxc_log "$name start"
114                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
115                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
116                  lxc-info  -n $name                  lxc-info  -n $name
# Line 105  lxc_start() { Line 118  lxc_start() {
118          fi          fi
119  }  }
120    
 lxc_log() {  
         echo `date +%Y-%m-%dT%H:%M:%S` $*  
 }  
   
121  lxc_watchdog() {  lxc_watchdog() {
122  name=$1  name=$1
123  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
# Line 152  while true; do Line 161  while true; do
161          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
162  done  done
163    
164  lxc_log "$name exited"  lxc_log "$name watchdog exited"
165    
166  }  }
167    
168    
169    usage() {
170            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
171            exit 3
172    }
173    
174  command_on_lxc() {  command_on_lxc() {
175  command=$1  command=$1
176  shift  shift
# Line 168  case "$command" in Line 182  case "$command" in
182  start)  start)
183          lxc_exists $1          lxc_exists $1
184          cleanup_init_scripts $1          cleanup_init_scripts $1
185          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
186          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
187            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
188          lxc_start $1          lxc_start $1
189          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
190          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 184  reload|force-reload|restart|reboot) Line 199  reload|force-reload|restart|reboot)
199  watchdog)  watchdog)
200          lxc_watchdog $1          lxc_watchdog $1
201          ;;          ;;
202    boot)
203            echo $1 > /var/lib/lxc/$1/on_boot
204            ;;
205    disable)
206            echo -n > /var/lib/lxc/$1/on_boot
207            ;;
208  *)  *)
209          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
210          ;;          ;;
211    
212  esac  esac
# Line 194  esac Line 214  esac
214  }  }
215    
216  command=$1  command=$1
217  shift  test -z "$command" && usage
   
218  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
219    shift
220    
221  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
222          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
223                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
224                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
225                            command_on_lxc $command $name
226                    else
227                            echo "# skip $command $name"
228                    fi
229          done          done
230  else  else
231          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.187  
changed lines
  Added in v.216

  ViewVC Help
Powered by ViewVC 1.1.26